%define releasebase 2 
#Use as deafults if no command line inputs
# define AFS defines here (only used if "--with afs" is given to rpmbuild):
%define afsarch amd
%define afsroot /afs/cad/hpc
#%define as_limulus 1
# allow --with[out] <feature> at rpm command line build
%{?_with_basement: %{expand: %%define as_basement 1}}
%{?_with_limulus: %{expand: %%define as_limulus 1}}
%{?_with_gnu3: %{expand: %%define as_gnu3 1}}
%{?_with_gnu4: %{expand: %%define as_gnu4 1}}
%{?_with_afs: %{expand: %%define as_afs 1}}

#pick the target, Limulus is default
%if "1" == "%{as_basement}"
%define targetbase Basement
%else
%if "1" == "%{as_afs}"
%define targetbase afs_%{afsarch}
%else
%define targetbase Limulus
%endif
%endif

# gnu4 is the default
%if "1" == "%{as_gnu3}"
Name: %{nbase}-gnu3
%else
Name: %{nbase}-gnu4
%endif


Summary: SGE6 Parallel Environments 
%define nbase  gridengine6-pe
%define sge6_root /opt/gridengine
Group: %{targetbase}/Admin
Release: %{releasebase}.%{targetbase}
Version:2.1
License: Copyright Basement Supercomputing
Source:  gridengine6-pe-%{version}.tgz
URL: www.basement-supercomputing.com
Distribution: SC Linux
BuildRoot: %{_tmppath}/%{name}-%{version}-root
BuildArch: noarch
Vendor: Douglas Eadline
Packager: deadline@basement-supercomputing.com
%define ver %{PACKAGE_VERSION}-%{PACKAGE_RELEASE}
Requires: gridengine 


%description
PE's for SGE6 
%prep 
%setup -n sge6

%build
/bin/true

%install
fix="ompi/ompi-pe.template \
mpich2/mpich2-pe.template  \
mpichgm/mpichgm-pe.template"
for i in $fix
do
 sed "s!FILL-IN_SGE_ROOT!%{sge6_root}!g"  $i >  $i.out
 /bin/mv  $i.out $i
done

#adjust for gnu level

%if "1" == "%{as_gnu3}"

fix="ompi/ompi_example_script.sh \
     mpich2/stopmpich2.sh \
     mpich2/startmpich2.sh \
     mpich2/mpich2_example_script.sh \
     mpich2/mpich2-pe.template  \
     mpichgm/mpichgm_example_script.sh "
for i in $fix
do
 sed "s!-gnu4!-gnu3!g"  $i >  $i.out
 /bin/mv  $i.out $i
done
%endif


mkdir -p  %{buildroot}%{sge6_root}
cp -R mpichgm   %{buildroot}%{sge6_root}
cp -R mpich2  %{buildroot}%{sge6_root}
cp -R ompi  %{buildroot}%{sge6_root}
cp -R threaded  %{buildroot}%{sge6_root}

%pre
if [ -f %{sge6_root}/default/spool/sge_qmaster/lock ] 
then
  echo "The sge_qmaster is not running, it must be started before "
  echo "the parallel environments can be installed"
  exit
else
 PID=`cat %{sge6_root}/default/spool/sge_qmaster/qmaster.pid`
 echo "sge_qmaster is running with PID=$PID, good!"
fi

%post

export SGE_ROOT=%{sge6_root}
export SGE_ARCH=`%{sge6_root}/util/arch`
echo "Installing Parallel Environments"
%{sge6_root}/bin/$SGE_ARCH/qconf -Ap %{sge6_root}/mpich2/mpich2-pe.template
%{sge6_root}/bin/$SGE_ARCH/qconf -Ap %{sge6_root}/mpichgm/mpichgm-pe.template
%{sge6_root}/bin/$SGE_ARCH/qconf -Ap %{sge6_root}/ompi/ompi-pe.template
%{sge6_root}/bin/$SGE_ARCH/qconf -Ap %{sge6_root}/threaded/threaded-pe.template
%postun
echo "Removing Parallel Environments"
export SGE_ROOT=%{sge6_root}
export SGE_ARCH=`%{sge6_root}/util/arch`
%{sge6_root}/bin/$SGE_ARCH/qconf -dp mpich2
%{sge6_root}/bin/$SGE_ARCH/qconf -dp mpichgm
%{sge6_root}/bin/$SGE_ARCH/qconf -dp ompi
%{sge6_root}/bin/$SGE_ARCH/qconf -dp threaded

%files
%defattr(-,root,root)
%{sge6_root}/mpichgm/*
%{sge6_root}/mpich2/*
%{sge6_root}/ompi/*
%{sge6_root}/threaded/*
%clean
if [ %{?buildroot:%{buildroot}} != "/" ]; then
  rm -rf %{?buildroot:%{buildroot}}
fi

